<?php
namespace Typo3\Issue78128\Domain\Model;

/***
 *
 * This file is part of the "Issue78128" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2016 Robert Jelinek
 *
 ***/

/**
 * TableA
 */
class TableA extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * c
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableC>
     * @cascade remove
     */
    protected $c = null;

    /**
     * b
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableB>
     * @cascade remove
     */
    protected $b = null;

    /**
     * __construct
     */
    public function __construct()
    {
        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->c = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->b = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Adds a TableC
     *
     * @param \Typo3\Issue78128\Domain\Model\TableC $c
     * @return void
     */
    public function addC(\Typo3\Issue78128\Domain\Model\TableC $c)
    {
        $this->c->attach($c);
    }

    /**
     * Removes a TableC
     *
     * @param \Typo3\Issue78128\Domain\Model\TableC $cToRemove The TableC to be removed
     * @return void
     */
    public function removeC(\Typo3\Issue78128\Domain\Model\TableC $cToRemove)
    {
        $this->c->detach($cToRemove);
    }

    /**
     * Returns the c
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableC> $c
     */
    public function getC()
    {
        return $this->c;
    }

    /**
     * Sets the c
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableC> $c
     * @return void
     */
    public function setC(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $c)
    {
        $this->c = $c;
    }

    /**
     * Adds a TableB
     *
     * @param \Typo3\Issue78128\Domain\Model\TableB $b
     * @return void
     */
    public function addB(\Typo3\Issue78128\Domain\Model\TableB $b)
    {
        $this->b->attach($b);
    }

    /**
     * Removes a TableB
     *
     * @param \Typo3\Issue78128\Domain\Model\TableB $bToRemove The TableB to be removed
     * @return void
     */
    public function removeB(\Typo3\Issue78128\Domain\Model\TableB $bToRemove)
    {
        $this->b->detach($bToRemove);
    }

    /**
     * Returns the b
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableB> $b
     */
    public function getB()
    {
        return $this->b;
    }

    /**
     * Sets the b
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Typo3\Issue78128\Domain\Model\TableB> $b
     * @return void
     */
    public function setB(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $b)
    {
        $this->b = $b;
    }
}
